Erlang -- kernel

Reference Manual
Release Notes
PDF
Top

Kernel
Reference Manual
Version 5.1

Expand All
Contract All

Table of Contents

- kernel (App)
- application
  - Top of manual page
  - ensure_all_started/1
  - ensure_all_started/2
  - ensure_started/1
  - ensure_started/2
  - get_all_env/0
  - get_all_env/1
  - get_all_key/0
  - get_all_key/1
  - get_application/0
  - get_application/1
  - get_env/1
  - get_env/2
  - get_env/3
  - get_key/1
  - get_key/2
  - load/1
  - load/2
  - loaded_applications/0
  - permit/2
  - set_env/3
  - set_env/4
  - start/1
  - start/2
  - start_type/0
  - stop/1
  - takeover/2
  - unload/1
  - unset_env/2
  - unset_env/3
  - which_applications/0
  - which_applications/1
  - Module:config_change/3
  - Module:prep_stop/1
  - Module:start/2
  - Module:start_phase/3
  - Module:stop/1
- auth
  - Top of manual page
  - cookie/0
  - cookie/1
  - is_auth/1
  - node_cookie/2
  - node_cookie/1
- code
  - Top of manual page
  - add_path/1
  - add_patha/1
  - add_paths/1
  - add_pathsa/1
  - add_pathsz/1
  - add_pathz/1
  - all_loaded/0
  - atomic_load/1
  - clash/0
  - compiler_dir/0
  - del_path/1
  - delete/1
  - ensure_loaded/1
  - ensure_modules_loaded/1
  - finish_loading/1
  - get_mode/0
  - get_object_code/1
  - get_path/0
  - is_loaded/1
  - is_module_native/1
  - is_sticky/1
  - lib_dir/0
  - lib_dir/1
  - lib_dir/2
  - load_abs/1
  - load_binary/3
  - load_file/1
  - objfile_extension/0
  - prepare_loading/1
  - priv_dir/1
  - purge/1
  - replace_path/2
  - root_dir/0
  - set_path/1
  - soft_purge/1
  - stick_dir/1
  - unstick_dir/1
  - where_is_file/1
  - which/1
- disk_log
  - Top of manual page
  - accessible_logs/0
  - alog/2
  - alog_terms/2
  - balog/2
  - balog_terms/2
  - bchunk/2
  - bchunk/3
  - block/1
  - block/2
  - blog/2
  - blog_terms/2
  - breopen/3
  - btruncate/2
  - change_header/2
  - change_notify/3
  - change_size/2
  - chunk/2
  - chunk/3
  - chunk_info/1
  - chunk_step/3
  - close/1
  - format_error/1
  - inc_wrap_file/1
  - info/1
  - lclose/1
  - lclose/2
  - log/2
  - log_terms/2
  - open/1
  - pid2name/1
  - reopen/2
  - reopen/3
  - sync/1
  - truncate/1
  - truncate/2
  - unblock/1
- erl_boot_server
  - Top of manual page
  - add_slave/1
  - delete_slave/1
  - start/1
  - start_link/1
  - which_slaves/0
- erl_ddll
  - Top of manual page
  - demonitor/1
  - format_error/1
  - info/0
  - info/1
  - info/2
  - load/2
  - load_driver/2
  - loaded_drivers/0
  - monitor/2
  - reload/2
  - reload_driver/2
  - try_load/3
  - try_unload/2
  - unload/1
  - unload_driver/1
- erl_prim_loader
- erlang
- error_handler
  - Top of manual page
  - raise_undef_exception/3
  - undefined_function/3
  - undefined_lambda/3
- error_logger
  - Top of manual page
  - add_report_handler/1
  - add_report_handler/2
  - delete_report_handler/1
  - error_msg/1
  - error_msg/2
  - error_report/1
  - error_report/2
  - format/2
  - info_msg/1
  - info_msg/2
  - info_report/1
  - info_report/2
  - logfile/1
  - tty/1
  - warning_map/0
  - warning_msg/1
  - warning_msg/2
  - warning_report/1
  - warning_report/2
- file
  - Top of manual page
  - advise/4
  - allocate/3
  - change_group/2
  - change_mode/2
  - change_owner/2
  - change_owner/3
  - change_time/2
  - change_time/3
  - close/1
  - consult/1
  - copy/2
  - copy/3
  - datasync/1
  - del_dir/1
  - delete/1
  - eval/1
  - eval/2
  - format_error/1
  - get_cwd/0
  - get_cwd/1
  - list_dir/1
  - list_dir_all/1
  - make_dir/1
  - make_link/2
  - make_symlink/2
  - native_name_encoding/0
  - open/2
  - path_consult/2
  - path_eval/2
  - path_open/3
  - path_script/2
  - path_script/3
  - pid2name/1
  - position/2
  - pread/2
  - pread/3
  - pwrite/2
  - pwrite/3
  - read/2
  - read_file/1
  - read_file_info/1
  - read_file_info/2
  - read_line/1
  - read_link/1
  - read_link_all/1
  - read_link_info/1
  - read_link_info/2
  - rename/2
  - script/1
  - script/2
  - sendfile/2
  - sendfile/5
  - set_cwd/1
  - sync/1
  - truncate/1
  - write/2
  - write_file/2
  - write_file/3
  - write_file_info/2
  - write_file_info/3
- gen_sctp
  - Top of manual page
  - abort/2
  - close/1
  - connect/4
  - connect/5
  - connect_init/4
  - connect_init/5
  - controlling_process/2
  - eof/2
  - error_string/1
  - listen/2
  - open/0
  - open/1
  - open/2
  - peeloff/2
  - recv/1
  - recv/2
  - send/3
  - send/4
- gen_tcp
  - Top of manual page
  - accept/1
  - accept/2
  - close/1
  - connect/3
  - connect/4
  - controlling_process/2
  - listen/2
  - recv/2
  - recv/3
  - send/2
  - shutdown/2
- gen_udp
  - Top of manual page
  - close/1
  - controlling_process/2
  - open/1
  - open/2
  - recv/2
  - recv/3
  - send/4
- global
  - Top of manual page
  - del_lock/1
  - del_lock/2
  - notify_all_name/3
  - random_exit_name/3
  - random_notify_name/3
  - re_register_name/2
  - re_register_name/3
  - register_name/2
  - register_name/3
  - registered_names/0
  - send/2
  - set_lock/1
  - set_lock/2
  - set_lock/3
  - sync/0
  - trans/2
  - trans/3
  - trans/4
  - unregister_name/1
  - whereis_name/1
- global_group
  - Top of manual page
  - global_groups/0
  - info/0
  - monitor_nodes/1
  - own_nodes/0
  - registered_names/1
  - send/2
  - send/3
  - sync/0
  - whereis_name/1
  - whereis_name/2
- heart
  - Top of manual page
  - clear_callback/0
  - clear_cmd/0
  - get_callback/0
  - get_cmd/0
  - get_options/0
  - set_callback/2
  - set_cmd/1
  - set_options/1
- inet
  - Top of manual page
  - close/1
  - format_error/1
  - get_rc/0
  - getaddr/2
  - getaddrs/2
  - gethostbyaddr/1
  - gethostbyname/1
  - gethostbyname/2
  - gethostname/0
  - getifaddrs/0
  - getopts/2
  - getstat/1
  - getstat/2
  - ntoa/1
  - parse_address/1
  - parse_ipv4_address/1
  - parse_ipv4strict_address/1
  - parse_ipv6_address/1
  - parse_ipv6strict_address/1
  - parse_strict_address/1
  - peername/1
  - peernames/1
  - peernames/2
  - port/1
  - setopts/2
  - sockname/1
  - socknames/1
  - socknames/2
- inet_res
  - Top of manual page
  - getbyname/2
  - getbyname/3
  - gethostbyaddr/1
  - gethostbyaddr/2
  - gethostbyname/1
  - gethostbyname/2
  - gethostbyname/3
  - lookup/3
  - lookup/4
  - lookup/5
  - nnslookup/4
  - nnslookup/5
  - nslookup/3
  - nslookup/4
  - resolve/3
  - resolve/4
  - resolve/5
- init
- net_adm
  - Top of manual page
  - dns_hostname/1
  - host_file/0
  - localhost/0
  - names/0
  - names/1
  - ping/1
  - world/0
  - world/1
  - world_list/1
  - world_list/2
- net_kernel
  - Top of manual page
  - allow/1
  - connect_node/1
  - get_net_ticktime/0
  - getopts/2
  - monitor_nodes/1
  - monitor_nodes/2
  - set_net_ticktime/1
  - set_net_ticktime/2
  - setopts/2
  - start/1
  - start/1
  - start/1
  - stop/0
- os
  - Top of manual page
  - cmd/1
  - find_executable/1
  - find_executable/2
  - getenv/0
  - getenv/1
  - getenv/2
  - getpid/0
  - perf_counter/0
  - perf_counter/1
  - putenv/2
  - system_time/0
  - system_time/1
  - timestamp/0
  - type/0
  - unsetenv/1
  - version/0
- pg2
  - Top of manual page
  - create/1
  - delete/1
  - get_closest_pid/1
  - get_local_members/1
  - get_members/1
  - join/2
  - leave/2
  - start/0
  - start_link/0
  - which_groups/0
- rpc
  - Top of manual page
  - abcast/2
  - abcast/3
  - async_call/4
  - block_call/4
  - block_call/5
  - call/4
  - call/5
  - cast/4
  - eval_everywhere/3
  - eval_everywhere/4
  - multi_server_call/2
  - multi_server_call/3
  - multicall/3
  - multicall/4
  - multicall/5
  - nb_yield/1
  - nb_yield/2
  - parallel_eval/1
  - pinfo/1
  - pinfo/2
  - pmap/3
  - sbcast/2
  - sbcast/3
  - server_call/4
  - yield/1
- seq_trace
  - Top of manual page
  - get_system_tracer/0
  - get_token/0
  - get_token/1
  - print/1
  - print/2
  - reset_trace/0
  - set_system_tracer/1
  - set_token/1
  - set_token/2
- user
- wrap_log_reader
  - Top of manual page
  - chunk/1
  - chunk/2
  - close/1
  - open/1
  - open/2
- zlib
- app
- config

# kernel

### APPLICATION

kernel

### APPLICATION SUMMARY

The Kernel application.

### DESCRIPTION

The Kernel application has all the code necessary to run the Erlang runtime system: file servers, code servers, and so on.

The Kernel application is the first application started. It is mandatory in the sense that the minimal system based on Erlang/OTP consists of Kernel and STDLIB. Kernel contains the following functional areas:

- Start, stop, supervision, configuration, and distribution of applications
- Code loading
- Logging
- Error logging
- Global name service
- Supervision of Erlang/OTP
- Communication with sockets
- Operating system interface

### Error Logger Event Handlers

Two standard error logger event handlers are defined in the Kernel application. These are described in error_logger(3).

### Configuration

The following configuration parameters are defined for the Kernel application. For more information about configuration parameters, see file app(4).

browser_cmd = string() | {M,F,A}

  When pressing the Help button in a tool such as Debugger, the help text (an HTML file File) is by default displayed in a Netscape browser, which is required to be operational. This parameter can be used to change the command for how to display the help text if another browser than Netscape is preferred, or if another platform than Unix or Windows is used.

  If set to a string Command, the command "Command File" is evaluated using os:cmd/1.

  If set to a module-function-args tuple, {M,F,A}, the call apply(M,F,[File|A]) is evaluated.

distributed = [Distrib]

  Specifies which applications that are distributed and on which nodes they are allowed to execute. In this parameter:

  - Distrib = {App,Nodes} | {App,Time,Nodes}
  - App = atom()
  - Time = integer()>0
  - Nodes = [node() | {node(),...,node()}]

  The parameter is described in application:load/2.

dist_auto_connect = Value

  Specifies when nodes are automatically connected. If this parameter is not specified, a node is always automatically connected, for example, when a message is to be sent to that node. Value is one of:

  never

    Connections are never automatically established, they must be explicitly connected. See net_kernel(3).

  once

    Connections are established automatically, but only once per node. If a node goes down, it must thereafter be explicitly connected. See net_kernel(3).

permissions = [Perm]

  Specifies the default permission for applications when they are started. In this parameter:

  - Perm = {ApplName,Bool}
  - ApplName = atom()
  - Bool = boolean()

  Permissions are described in application:permit/2.

error_logger = Value

  Value is one of:

  tty

    Installs the standard event handler, which prints error reports to stdio. This is the default option.

  {file, FileName}

    Installs the standard event handler, which prints error reports to file FileName, where FileName is a string.

  false

    No standard event handler is installed, but the initial, primitive event handler is kept, printing raw event messages to tty.

  silent

    Error logging is turned off.

error_logger_format_depth = Depth

  Can be used to limit the size of the formatted output from the error logger event handlers.

  Note

  This configuration parameter was introduced in OTP 18.1 and is experimental. Based on user feedback, it can be changed or improved in future releases, for example, to gain better control over how to limit the size of the formatted output. We have no plans to remove this new feature entirely, unless it turns out to be useless.

  Depth is a positive integer representing the maximum depth to which terms are printed by the error logger event handlers included in OTP. This configuration parameter is used by the two event handlers defined by the Kernel application and the two event handlers in the SASL application. (If you have implemented your own error handlers, this configuration parameter has no effect on them.)

  Depth is used as follows: Format strings passed to the event handlers are rewritten. The format controls ~p and ~w are replaced with ~P and ~W, respectively, and Depth is used as the depth parameter. For details, see io:format/2 in STDLIB.

  Note

  A reasonable starting value for Depth is 30. We recommend to test crashing various processes in your application, examine the logs from the crashes, and then increase or decrease the value.

global_groups = [GroupTuple]

  Defines global groups, see global_group(3). In this parameter:

  - GroupTuple = {GroupName, [Node]} | {GroupName, PublishType, [Node]}

  - GroupName = atom()

  - PublishType = normal | hidden

  - Node = node()

inet_default_connect_options = [{Opt, Val}]

  Specifies default options for connect sockets, see inet(3).

inet_default_listen_options = [{Opt, Val}]

  Specifies default options for listen (and accept) sockets, see inet(3).

{inet_dist_use_interface, ip_address()}

  If the host of an Erlang node has many network interfaces, this parameter specifies which one to listen on. For the type definition of ip_address(), see inet(3).

{inet_dist_listen_min, First} and {inet_dist_listen_max, Last}

  Defines the First..Last port range for the listener socket of a distributed Erlang node.

{inet_dist_listen_options, Opts}

  Defines a list of extra socket options to be used when opening the listening socket for a distributed Erlang node. See gen_tcp:listen/2.

{inet_dist_connect_options, Opts}

  Defines a list of extra socket options to be used when connecting to other distributed Erlang nodes. See gen_tcp:connect/4.

inet_parse_error_log = silent

  If set, no error_logger messages are generated when erroneous lines are found and skipped in the various Inet configuration files.

inetrc = Filename

  The name (string) of an Inet user configuration file. For details, see section Inet Configuration in the ERTS User's Guide.

net_setuptime = SetupTime

  SetupTime must be a positive integer or floating point number, and is interpreted as the maximum allowed time for each network operation during connection setup to another Erlang node. The maximum allowed value is 120. If higher values are specified, 120 is used. Default is 7 seconds if the variable is not specified, or if the value is incorrect (for example, not a number).

  Notice that this value does not limit the total connection setup time, but rather each individual network operation during the connection setup and handshake.

net_ticktime = TickTime

  Specifies the net_kernel tick time. TickTime is specified in seconds. Once every TickTime/4 second, all connected nodes are ticked (if anything else is written to a node). If nothing is received from another node within the last four tick times, that node is considered to be down. This ensures that nodes that are not responding, for reasons such as hardware errors, are considered to be down.

  The time T, in which a node that is not responding is detected, is calculated as MinT < T < MaxT, where:

      MinT = TickTime - TickTime / 4
      MaxT = TickTime + TickTime / 4

  TickTime defaults to 60 (seconds). Thus, 45 < T < 75 seconds.

  Notice that all communicating nodes are to have the same TickTime value specified.

  Normally, a terminating node is detected immediately.

shutdown_timeout = integer() | infinity

  Specifies the time application_controller waits for an application to terminate during node shutdown. If the timer expires, application_controller brutally kills application_master of the hanging application. If this parameter is undefined, it defaults to infinity.

sync_nodes_mandatory = [NodeName]

  Specifies which other nodes that must be alive for this node to start properly. If some node in the list does not start within the specified time, this node does not start either. If this parameter is undefined, it defaults to [].

sync_nodes_optional = [NodeName]

  Specifies which other nodes that can be alive for this node to start properly. If some node in this list does not start within the specified time, this node starts anyway. If this parameter is undefined, it defaults to the empty list.

sync_nodes_timeout = integer() | infinity

  Specifies the time (in milliseconds) that this node waits for the mandatory and optional nodes to start. If this parameter is undefined, no node synchronization is performed. This option ensures that global is synchronized.

start_dist_ac = true | false

  Starts the dist_ac server if the parameter is true. This parameter is to be set to true for systems using distributed applications.

  Defaults to false. If this parameter is undefined, the server is started if parameter distributed is set.

start_boot_server = true | false

  Starts the boot_server if the parameter is true (see erl_boot_server(3)). This parameter is to be set to true in an embedded system using this service.

  Defaults to false.

boot_server_slaves = [SlaveIP]

  If configuration parameter start_boot_server is true, this parameter can be used to initialize boot_server with a list of slave IP addresses:

  SlaveIP = string() | atom | {integer(),integer(),integer(),integer()},

  where 0 <= integer() <=255.

  Examples of SlaveIP in atom, string, and tuple form:

  '150.236.16.70', "150,236,16,70", {150,236,16,70}.

  Defaults to [].

start_disk_log = true | false

  Starts the disk_log_server if the parameter is true (see disk_log(3)). This parameter is to be set to true in an embedded system using this service.

  Defaults to false.

start_pg2 = true | false

  Starts the pg2 server (see pg2(3)) if the parameter is true. This parameter is to be set to true in an embedded system that uses this service.

  Defaults to false.

start_timer = true | false

  Starts the timer_server if the parameter is true (see timer(3)). This parameter is to be set to true in an embedded system using this service.

  Defaults to false.

shutdown_func = {Mod, Func}

  Where:

  - Mod = atom()
  - Func = atom()

  Sets a function that application_controller calls when it starts to terminate. The function is called as Mod:Func(Reason), where Reason is the terminate reason for application_controller, and it must return as soon as possible for application_controller to terminate properly.

### See Also

app(4), application(3), code(3), disk_log(3), erl_boot_server(3), erl_ddll(3), error_logger(3), file(3), global(3), global_group(3), heart(3), inet(3), net_kernel(3), os(3), pg2(3), rpc(3), seq_trace(3), user(3), timer(3)